﻿<?xml version="1.0" encoding="utf-8"?>
<Dsl xmlns:dm0="http://schemas.microsoft.com/VisualStudio/2008/DslTools/Core" dslVersion="1.0.0.0" Id="e76b5f9b-81a1-45f0-ac20-8a25077fff36" Description="Description for HeuristicLab.SimulationCore.HLSim" Name="HLSim" DisplayName="HLSim" Namespace="HeuristicLab.SimulationCore" ProductName="HeuristicLab" CompanyName="HEAL" PackageGuid="fab8f4d5-e0e8-4756-917b-6979bfd5ce3a" PackageNamespace="HeuristicLab.SimulationCore" xmlns="http://schemas.microsoft.com/VisualStudio/2005/DslTools/DslDefinitionModel">
  <Classes>
    <DomainClass Id="bf3fdcd7-a552-4140-a502-130d51fa2a89" Description="The root in which all other elements are embedded. Appears as a diagram." Name="SimulationModel" DisplayName="Simulation Model" Namespace="HeuristicLab.SimulationCore">
      <Properties>
        <DomainProperty Id="495a3211-d774-4434-8bd1-7b340049f9e9" Description="Description for HeuristicLab.SimulationCore.SimulationModel.Model Type" Name="ModelType" DisplayName="Model Type">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Activity" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>SimulationModelHasActivities.Activities</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Action" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>SimulationModelHasActions.Actions</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="168d4729-6156-4a96-87c5-6f8e7dbe5a0f" Description="Description for HeuristicLab.SimulationCore.Activity" Name="Activity" DisplayName="Activity" Namespace="HeuristicLab.SimulationCore">
      <Properties>
        <DomainProperty Id="5d66e342-eb3f-43c5-a12d-e752689e360f" Description="Description for HeuristicLab.SimulationCore.Activity.Name" Name="Name" DisplayName="Name" IsElementName="true">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
    <DomainClass Id="d7ac7ca2-929b-4f0c-b690-e05a92bf28ed" Description="Description for HeuristicLab.SimulationCore.Action" Name="Action" DisplayName="Action" Namespace="HeuristicLab.SimulationCore">
      <Properties>
        <DomainProperty Id="3b4b0b0d-cb17-48f2-b0e1-45c23fd2c379" Description="Description for HeuristicLab.SimulationCore.Action.Name" Name="Name" DisplayName="Name" IsElementName="true">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
  </Classes>
  <Relationships>
    <DomainRelationship Id="4a4161d0-95d3-4727-8959-372bd8ba3fc7" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActivities" Name="SimulationModelHasActivities" DisplayName="Simulation Model Has Activities" Namespace="HeuristicLab.SimulationCore" IsEmbedding="true">
      <Source>
        <DomainRole Id="1026f01d-c2bd-47e0-a7f9-01c0551c0e8d" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActivities.SimulationModel" Name="SimulationModel" DisplayName="Simulation Model" PropertyName="Activities" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Activities">
          <RolePlayer>
            <DomainClassMoniker Name="SimulationModel" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="cd685a0e-906c-49b2-bc7b-0bdcc439b69e" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActivities.Activity" Name="Activity" DisplayName="Activity" PropertyName="SimulationModel" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Simulation Model">
          <RolePlayer>
            <DomainClassMoniker Name="Activity" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="4f6020f0-423c-4469-af3f-09ac8db8d19a" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActions" Name="SimulationModelHasActions" DisplayName="Simulation Model Has Actions" Namespace="HeuristicLab.SimulationCore" IsEmbedding="true">
      <Source>
        <DomainRole Id="5f2e5817-063b-4f23-a996-d490ac05ec40" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActions.SimulationModel" Name="SimulationModel" DisplayName="Simulation Model" PropertyName="Actions" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Actions">
          <RolePlayer>
            <DomainClassMoniker Name="SimulationModel" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="a7f0817d-4f04-49ef-9592-e2f78432cc4f" Description="Description for HeuristicLab.SimulationCore.SimulationModelHasActions.Action" Name="Action" DisplayName="Action" PropertyName="SimulationModel" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Simulation Model">
          <RolePlayer>
            <DomainClassMoniker Name="Action" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="717952d5-7c93-4315-8e41-453cffe17811" Description="Description for HeuristicLab.SimulationCore.ActivityReferencesTriggers" Name="ActivityReferencesTriggers" DisplayName="Activity References Triggers" Namespace="HeuristicLab.SimulationCore">
      <Source>
        <DomainRole Id="7796065f-0003-4aec-bf7a-6d22b99f7c4b" Description="Description for HeuristicLab.SimulationCore.ActivityReferencesTriggers.Activity" Name="Activity" DisplayName="Activity" PropertyName="Triggers" PropertyDisplayName="Triggers">
          <RolePlayer>
            <DomainClassMoniker Name="Activity" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="93b557c0-5b55-4e27-aa06-6edfbe508585" Description="Description for HeuristicLab.SimulationCore.ActivityReferencesTriggers.Action" Name="Action" DisplayName="Action" PropertyName="Activities" PropertyDisplayName="Activities">
          <RolePlayer>
            <DomainClassMoniker Name="Action" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="448eff77-5a72-420f-befa-d599574bb485" Description="Description for HeuristicLab.SimulationCore.ActionReferencesListeners" Name="ActionReferencesListeners" DisplayName="Action References Listeners" Namespace="HeuristicLab.SimulationCore">
      <Source>
        <DomainRole Id="0e8492e9-920e-4d6c-b398-53844a0b8294" Description="Description for HeuristicLab.SimulationCore.ActionReferencesListeners.Action" Name="Action" DisplayName="Action" PropertyName="Listeners" PropertyDisplayName="Listeners">
          <RolePlayer>
            <DomainClassMoniker Name="Action" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="ab4b8a78-aa3e-4315-8bfd-e41126a5bc7a" Description="Description for HeuristicLab.SimulationCore.ActionReferencesListeners.Activity" Name="Activity" DisplayName="Activity" PropertyName="Actions" PropertyDisplayName="Actions">
          <RolePlayer>
            <DomainClassMoniker Name="Activity" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
  </Relationships>
  <Types>
    <ExternalType Name="DateTime" Namespace="System" />
    <ExternalType Name="String" Namespace="System" />
    <ExternalType Name="Int16" Namespace="System" />
    <ExternalType Name="Int32" Namespace="System" />
    <ExternalType Name="Int64" Namespace="System" />
    <ExternalType Name="UInt16" Namespace="System" />
    <ExternalType Name="UInt32" Namespace="System" />
    <ExternalType Name="UInt64" Namespace="System" />
    <ExternalType Name="SByte" Namespace="System" />
    <ExternalType Name="Byte" Namespace="System" />
    <ExternalType Name="Double" Namespace="System" />
    <ExternalType Name="Single" Namespace="System" />
    <ExternalType Name="Guid" Namespace="System" />
    <ExternalType Name="Boolean" Namespace="System" />
    <ExternalType Name="Char" Namespace="System" />
  </Types>
  <Shapes>
    <GeometryShape Id="9aa624f1-2625-4cc3-b759-7070505f1a8b" Description="Description for HeuristicLab.SimulationCore.ActivityShape" Name="ActivityShape" DisplayName="Activity Shape" Namespace="HeuristicLab.SimulationCore" FixedTooltipText="Activity Shape" FillColor="DarkKhaki" InitialWidth="1.62" InitialHeight="1" Geometry="RoundedRectangle">
      <ShapeHasDecorators Position="InnerTopLeft" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="NameDecorator" DisplayName="Name Decorator" DefaultText="NameDecorator" />
      </ShapeHasDecorators>
    </GeometryShape>
    <GeometryShape Id="25205757-e7e3-4310-b3c8-e4b85c91b152" Description="Description for HeuristicLab.SimulationCore.ActionShape" Name="ActionShape" DisplayName="Action Shape" Namespace="HeuristicLab.SimulationCore" FixedTooltipText="Action Shape" FillColor="IndianRed" InitialWidth="0.75" InitialHeight="0.75" Geometry="Circle">
      <ShapeHasDecorators Position="InnerTopLeft" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="NameDecorator" DisplayName="Name Decorator" DefaultText="NameDecorator" />
      </ShapeHasDecorators>
    </GeometryShape>
  </Shapes>
  <Connectors>
    <Connector Id="ff67e59a-021e-472d-8fdc-0298ee26fe8e" Description="Description for HeuristicLab.SimulationCore.Trigger" Name="Trigger" DisplayName="Trigger" Namespace="HeuristicLab.SimulationCore" FixedTooltipText="Trigger" TargetEndStyle="EmptyArrow" />
    <Connector Id="84ebcd29-fe73-4fa2-8e01-ce82534fb35c" Description="Description for HeuristicLab.SimulationCore.Listener" Name="Listener" DisplayName="Listener" Namespace="HeuristicLab.SimulationCore" FixedTooltipText="Listener" DashStyle="Dot" TargetEndStyle="EmptyArrow" />
  </Connectors>
  <XmlSerializationBehavior Name="HLSimSerializationBehavior" Namespace="HeuristicLab.SimulationCore">
    <ClassData>
      <XmlClassData TypeName="SimulationModel" MonikerAttributeName="" SerializeId="true" MonikerElementName="simulationModelMoniker" ElementName="simulationModel" MonikerTypeName="SimulationModelMoniker">
        <DomainClassMoniker Name="SimulationModel" />
        <ElementData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="activities">
            <DomainRelationshipMoniker Name="SimulationModelHasActivities" />
          </XmlRelationshipData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="actions">
            <DomainRelationshipMoniker Name="SimulationModelHasActions" />
          </XmlRelationshipData>
          <XmlPropertyData XmlName="modelType">
            <DomainPropertyMoniker Name="SimulationModel/ModelType" />
          </XmlPropertyData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="HLSimDiagram" MonikerAttributeName="" SerializeId="true" MonikerElementName="hLSimDiagramMoniker" ElementName="hLSimDiagram" MonikerTypeName="HLSimDiagramMoniker">
        <DiagramMoniker Name="HLSimDiagram" />
      </XmlClassData>
      <XmlClassData TypeName="Activity" MonikerAttributeName="" SerializeId="true" MonikerElementName="activityMoniker" ElementName="activity" MonikerTypeName="ActivityMoniker">
        <DomainClassMoniker Name="Activity" />
        <ElementData>
          <XmlPropertyData XmlName="name">
            <DomainPropertyMoniker Name="Activity/Name" />
          </XmlPropertyData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="triggers">
            <DomainRelationshipMoniker Name="ActivityReferencesTriggers" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="Action" MonikerAttributeName="" SerializeId="true" MonikerElementName="actionMoniker" ElementName="action" MonikerTypeName="ActionMoniker">
        <DomainClassMoniker Name="Action" />
        <ElementData>
          <XmlPropertyData XmlName="name">
            <DomainPropertyMoniker Name="Action/Name" />
          </XmlPropertyData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="listeners">
            <DomainRelationshipMoniker Name="ActionReferencesListeners" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="SimulationModelHasActivities" MonikerAttributeName="" SerializeId="true" MonikerElementName="simulationModelHasActivitiesMoniker" ElementName="simulationModelHasActivities" MonikerTypeName="SimulationModelHasActivitiesMoniker">
        <DomainRelationshipMoniker Name="SimulationModelHasActivities" />
      </XmlClassData>
      <XmlClassData TypeName="SimulationModelHasActions" MonikerAttributeName="" SerializeId="true" MonikerElementName="simulationModelHasActionsMoniker" ElementName="simulationModelHasActions" MonikerTypeName="SimulationModelHasActionsMoniker">
        <DomainRelationshipMoniker Name="SimulationModelHasActions" />
      </XmlClassData>
      <XmlClassData TypeName="ActivityReferencesTriggers" MonikerAttributeName="" SerializeId="true" MonikerElementName="activityReferencesTriggersMoniker" ElementName="activityReferencesTriggers" MonikerTypeName="ActivityReferencesTriggersMoniker">
        <DomainRelationshipMoniker Name="ActivityReferencesTriggers" />
      </XmlClassData>
      <XmlClassData TypeName="ActionReferencesListeners" MonikerAttributeName="" SerializeId="true" MonikerElementName="actionReferencesListenersMoniker" ElementName="actionReferencesListeners" MonikerTypeName="ActionReferencesListenersMoniker">
        <DomainRelationshipMoniker Name="ActionReferencesListeners" />
      </XmlClassData>
      <XmlClassData TypeName="ActivityShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="activityShapeMoniker" ElementName="activityShape" MonikerTypeName="ActivityShapeMoniker">
        <GeometryShapeMoniker Name="ActivityShape" />
      </XmlClassData>
      <XmlClassData TypeName="ActionShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="actionShapeMoniker" ElementName="actionShape" MonikerTypeName="ActionShapeMoniker">
        <GeometryShapeMoniker Name="ActionShape" />
      </XmlClassData>
      <XmlClassData TypeName="Trigger" MonikerAttributeName="" SerializeId="true" MonikerElementName="triggerMoniker" ElementName="trigger" MonikerTypeName="TriggerMoniker">
        <ConnectorMoniker Name="Trigger" />
      </XmlClassData>
      <XmlClassData TypeName="Listener" MonikerAttributeName="" SerializeId="true" MonikerElementName="listenerMoniker" ElementName="listener" MonikerTypeName="ListenerMoniker">
        <ConnectorMoniker Name="Listener" />
      </XmlClassData>
    </ClassData>
  </XmlSerializationBehavior>
  <ExplorerBehavior Name="HLSimExplorer" />
  <ConnectionBuilders>
    <ConnectionBuilder Name="ActivityReferencesTriggersBuilder">
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="ActivityReferencesTriggers" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Activity" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Action" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
    <ConnectionBuilder Name="ActionReferencesListenersBuilder">
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="ActionReferencesListeners" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Action" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Activity" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
  </ConnectionBuilders>
  <Diagram Id="cf1c9f0b-eb8e-4d36-9fcc-6cd2455f9cba" Description="Description for HeuristicLab.SimulationCore.HLSimDiagram" Name="HLSimDiagram" DisplayName="Minimal Language Diagram" Namespace="HeuristicLab.SimulationCore">
    <Class>
      <DomainClassMoniker Name="SimulationModel" />
    </Class>
    <ShapeMaps>
      <ShapeMap>
        <DomainClassMoniker Name="Activity" />
        <ParentElementPath>
          <DomainPath>SimulationModelHasActivities.SimulationModel/!SimulationModel</DomainPath>
        </ParentElementPath>
        <DecoratorMap>
          <TextDecoratorMoniker Name="ActivityShape/NameDecorator" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="Activity/Name" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
        <GeometryShapeMoniker Name="ActivityShape" />
      </ShapeMap>
      <ShapeMap>
        <DomainClassMoniker Name="Action" />
        <ParentElementPath>
          <DomainPath>SimulationModelHasActions.SimulationModel/!SimulationModel</DomainPath>
        </ParentElementPath>
        <DecoratorMap>
          <TextDecoratorMoniker Name="ActionShape/NameDecorator" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="Action/Name" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
        <GeometryShapeMoniker Name="ActionShape" />
      </ShapeMap>
    </ShapeMaps>
    <ConnectorMaps>
      <ConnectorMap>
        <ConnectorMoniker Name="Trigger" />
        <DomainRelationshipMoniker Name="ActivityReferencesTriggers" />
      </ConnectorMap>
      <ConnectorMap>
        <ConnectorMoniker Name="Listener" />
        <DomainRelationshipMoniker Name="ActionReferencesListeners" />
      </ConnectorMap>
    </ConnectorMaps>
  </Diagram>
  <Designer CopyPasteGeneration="CopyPasteOnly" FileExtension="hlsim" EditorGuid="c6d92072-93cd-4652-9e26-052db3ad40ce">
    <RootClass>
      <DomainClassMoniker Name="SimulationModel" />
    </RootClass>
    <XmlSerializationDefinition CustomPostLoad="false">
      <XmlSerializationBehaviorMoniker Name="HLSimSerializationBehavior" />
    </XmlSerializationDefinition>
    <ToolboxTab TabText="HLSim">
      <ElementTool Name="Activity" ToolboxIcon="Resources\ExampleShapeToolBitmap.bmp" Caption="Activity" Tooltip="Activity" HelpKeyword="Activity">
        <DomainClassMoniker Name="Activity" />
      </ElementTool>
      <ElementTool Name="Action" ToolboxIcon="Resources\ExampleShapeToolBitmap.bmp" Caption="Action" Tooltip="Action" HelpKeyword="Action">
        <DomainClassMoniker Name="Action" />
      </ElementTool>
      <ConnectionTool Name="Trigger" ToolboxIcon="Resources\ExampleConnectorToolBitmap.bmp" Caption="Trigger" Tooltip="Trigger" HelpKeyword="Trigger">
        <ConnectionBuilderMoniker Name="HLSim/ActivityReferencesTriggersBuilder" />
      </ConnectionTool>
      <ConnectionTool Name="Listener" ToolboxIcon="Resources\ExampleConnectorToolBitmap.bmp" Caption="Listener" Tooltip="Listener" HelpKeyword="Listener">
        <ConnectionBuilderMoniker Name="HLSim/ActionReferencesListenersBuilder" />
      </ConnectionTool>
    </ToolboxTab>
    <Validation UsesMenu="false" UsesOpen="false" UsesSave="false" UsesLoad="false" />
    <DiagramMoniker Name="HLSimDiagram" />
  </Designer>
  <Explorer ExplorerGuid="8ed281ac-3dd2-4c07-a131-eb7845494b19" Title="HLSim Explorer">
    <ExplorerBehaviorMoniker Name="HLSim/HLSimExplorer" />
  </Explorer>
</Dsl>